package org.gyun.jdbc;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.log4j.Logger;

/**
 * 
 * @ClassNameJdbcTest.java
 * @DescriptionJdbc
 * @AuthorDongGaoYun
 * @URL www.gyun.org
 * @EmailDongGaoYun@qq.com
 * @QQ1050968899
 * @WeiXinQingYunJiao
 * @Date2019-7-29 
 * @Version1.0
 */
public class JdbcTest {
	//
	// ־ļ
	private static Logger logger = Logger.getLogger(JdbcTest.class);
	private static Connection con;
	private static Statement st;
	private static PreparedStatement ps;
	// 
	private static ResultSet rs;

	public static void main(String[] args) {
		init();
		// getConnection();
		// ѯaaϢ
		// query();
		// add("zxl");
		// sqlעΣա
		// query("222' or '1'='1");
		queryPreParedStatement("222", 1);
	}

	// 2:һaaϢ
	private static void add(String name) {
		// ѯaaϢ
		String sql = "INSERT INTO AA(NAME) VALUES('" + name + "')";
		try {
			st = getConnection().createStatement();
			// 4. int,
			int num = st.executeUpdate(sql);
			if (num > 0) {
				logger.info("ӳɹ!");
			} else {
				logger.info("ʧ!");
			}
		} catch (SQLException e) {
			e.printStackTrace();
			logger.info("ʧ!");
			// 5.رԴ
		} finally {

			try {
				if (st != null)
					st.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				if (con != null)
					con.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}

		}
	}

	// sqlעΣա//Ľ
	// 3.PreparedStatement󣬷SQL
	private static void queryPreParedStatement(String names, int ids) {
		// ѯaaϢ ?ʾռλ
		String sql = "SELECT * FROM AA WHERE NAME=? AND ID=?";
		try {
			ps = getConnection().prepareStatement(sql);
			ps.setString(1, names);
			ps.setInt(2, ids);
			// st = getConnection().createStatement();
			// 4.ؽ()ResultSet int,
			// rsǽѯļ¼һбʼʱָָǵһ¼֮ǰġ
			rs = ps.executeQuery();
			// rs = st.executeQuery(sql);
			// System.out.println(sql);
			// ѭж
			// ȡ һ
			// ÿrs.next()һָ붼ƶһλָһ¼
			while (rs.next()) {
				int id = rs.getInt("id");
				String name = rs.getString(2);
				System.out.println("id=" + id + ": name=" + name);
			}
			logger.info("ѯɹ!");
		} catch (SQLException e) {
			e.printStackTrace();
			logger.info("ѯʧ!");
			// 5.رԴ
		} finally {
			try {
				if (rs != null)
					rs.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				if (st != null)
					st.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				if (con != null)
					con.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}

		}
	}

	// sqlעΣա
	// 3.Statement󣬷SQL
	private static void query(String names) {
		// ѯaaϢ
		String sql = "SELECT * FROM AA WHERE NAME='" + names + "'";
		try {
			st = getConnection().createStatement();
			// 4.ؽ()ResultSet int,
			rs = st.executeQuery(sql);
			System.out.println(sql);
			while (rs.next()) {
				int id = rs.getInt(1);
				String name = rs.getString(2);
				System.out.println("id=" + id + ": name=" + name);
			}
			logger.info("ѯɹ!");
		} catch (SQLException e) {
			e.printStackTrace();
			logger.info("ѯʧ!");
			// 5.رԴ
		} finally {
			try {
				if (rs != null)
					rs.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				if (st != null)
					st.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				if (con != null)
					con.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}

		}
	}

	// 3.Statement󣬷SQL
	private static void query() {
		// ѯaaϢ
		String sql = "SELECT * FROM AA";
		try {
			st = getConnection().createStatement();
			// 4.ؽ()ResultSet int,
			rs = st.executeQuery(sql);
			while (rs.next()) {
				int id = rs.getInt(1);
				String name = rs.getString(2);
				System.out.println("id=" + id + ": name=" + name);
			}
			logger.info("ѯɹ!");
		} catch (SQLException e) {
			e.printStackTrace();
			logger.error("ѯʧ!");
			// 5.رԴ
		} finally {
			try {
				if (rs != null)
					rs.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				if (st != null)
					st.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			try {
				if (con != null)
					con.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}

		}
	}

	// 1.
	private static void init() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			logger.info("ɹ!");
			// System.out.println("ɹ!");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
			logger.error("ʧ!");
		}
	}

	// 2.
	private static Connection getConnection() {
		String url = "jdbc:mysql://localhost:3306/p19";
		String user = "root";
		String password = "aaa";
		try {
			con = DriverManager.getConnection(url, user, password);
			logger.info("ӳɹ!");
		} catch (SQLException e) {
			e.printStackTrace();
			logger.error("ʧ!");
		}
		return con;
	}
}
